#
# Conditional build:
%bcond_with	asmopt	# without assembler optimization for i686+
			# (asm is unsupported by upstream and unmaintained)
#
# disable asmopt where not applicable
%ifarch i386 i486 i586
%undefine	with_asmopt
%endif
%ifnarch %{ix86}
%undefine	with_asmopt
%endif
%define		realname		zlib
Summary:	Library for compression and decompression - MinGW32 cross version
Summary(pl.UTF-8):	Biblioteka z podprogramami do kompresji i dekompresji - wersja skrośna dla MinGW32
Name:		crossmingw32-%{realname}
Version:	1.2.12
Release:	1
License:	BSD
Group:		Development/Libraries
Source0:	http://www.zlib.net/current/%{realname}-%{version}.tar.gz
# Source0-md5:	5fc414a9726be31427b440b434d05f78
URL:		http://www.zlib.net/
BuildRequires:	crossmingw32-gcc
BuildRequires:	sed >= 4.0
Requires:	crossmingw32-runtime
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		no_install_post_strip	1
%define		_enable_debug_packages	0

%define		target			i386-mingw32
%define		target_platform 	i386-pc-mingw32

%define		_sysprefix		/usr
%define		_prefix			%{_sysprefix}/%{target}
%define		_libdir			%{_prefix}/lib
%define		_pkgconfigdir		%{_prefix}/lib/pkgconfig
%define		_dlldir			/usr/share/wine/windows/system
%define		__cc			%{target}-gcc
%define		__cxx			%{target}-g++
%define		__pkgconfig_provides	%{nil}
%define		__pkgconfig_requires	%{nil}

%ifarch alpha sparc sparc64 sparcv9
%define		optflags	-O2
%endif

# -z options are invalid for mingw linker, most of -f options are Linux-specific
%define		filterout_ld	-Wl,-z,.*
%define		filterout_c		-f[-a-z0-9=]*

%description
The 'zlib' compression library provides in-memory compression and
decompression functions, including integrity checks of the
uncompressed data. This version of the library supports only one
compression method (deflation) but other algorithms may be added later
and will have the same stream interface.

This package contains the cross version for Win32.

%description -l pl.UTF-8
Biblioteka zlib udostępnia podprogramy do kompresji i dekompresji w
pamięci operacyjnej włącznie ze sprawdzaniem integralności w trakcie
dekompresji. Ta wersja biblioteki udostępnia tylko jedną metodę
kompresji o nazwie deflation niemniej inne algorytmy mogą być
dodawane udostępniając taki sam interfejs funkcji operujących na
strumieniu danych.

Ten pakiet zawiera wersję skrośną dla Win32.

%package static
Summary:	Static zlib library (cross MinGW32 version)
Summary(pl.UTF-8):	Statyczna biblioteka zlib (wersja skrośna MinGW32)
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}

%description static
Static zlib library (cross MinGW32 version).

%description static -l pl.UTF-8
Statyczna biblioteka zlib (wersja skrośna MinGW32).

%package dll
Summary:	zlib - DLL library for Windows
Summary(pl.UTF-8):	zlib - biblioteka DLL dla Windows
Group:		Applications/Emulators
Requires:	wine

%description dll
zlib - DLL library for Windows.

%description dll -l pl.UTF-8
zlib - biblioteka DLL dla Windows.

%prep
%setup -q -n %{realname}-%{version}

%if %{with asmopt}
%ifarch i686 athlon
cp contrib/asm686/match.S .
%endif
%endif

%build
%{__make} -fwin32/Makefile.gcc all \
	CC="%{__cc}" \
	CXX="%{__cxx}" \
	AR="%{target}-ar" \
	RANLIB="%{target}-ranlib" \
	CFLAGS="-D_REENTRANT -D_LARGEFILE64_SOURCE=1 %{rpmcflags}%{?with_asmopt: -DASMV}" \
	DLLWRAP="%{target}-dllwrap" \
	RC="%{target}-windres" \
	CP="install" \
	IMPLIB="libz.dll.a" \
	prefix="%{_prefix}" \
	%{?with_asmopt:OBJA=match.o}

# used by libtool to detect dependencies
cat << "EOF" >> libz.la
# libz.la - a libtool library file
# Generated by ltmain.sh - GNU libtool 1.5.22 (1.1220.2.365 2005/12/18 22:14:06)
# ^^^^ This line needs to stay
# Made by czarny czarny at pld-linux.org

# The name that we can dlopen(3).
dlname='%{_dlldir}/zlib1.dll'

# Names of this library.
library_names='libz.dll.a'

# The name of the static archive.
old_library='libz.a'

# Libraries that this one depends upon.
dependency_libs=''

# Version information for libz.
current=0
age=0
revision=0

# Is this an already installed library?
installed=yes

# Should we warn about portability when linking against -modules?
shouldnotlink=no

# Files to dlopen/dlpreopen
dlopen=''
dlpreopen=''

# Directory that this library needs to be installed in:
libdir='%{_libdir}'
EOF

sed -e 's=@prefix@=%{_prefix}=;s=@exec_prefix@=%{_prefix}=;s=@\(shared\)\?libdir@=%{_libdir}=;s=@includedir@=%{_includedir}=;s=@VERSION@=%{version}=' \
	< zlib.pc.in > zlib.pc

%if 0%{!?debug:1}
%{target}-strip -R.comment -R.note zlib1.dll
%{target}-strip -g -R.comment -R.note *.a
%endif

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{%{_libdir},%{_includedir},%{_dlldir},%{_pkgconfigdir}}

install zlib.h $RPM_BUILD_ROOT%{_includedir}
install zconf.h $RPM_BUILD_ROOT%{_includedir}
install libz.dll.a $RPM_BUILD_ROOT%{_libdir}
install libz.a $RPM_BUILD_ROOT%{_libdir}
install libz.la $RPM_BUILD_ROOT%{_libdir}
install zlib1.dll $RPM_BUILD_ROOT%{_dlldir}
install zlib.pc $RPM_BUILD_ROOT%{_pkgconfigdir}

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%{_libdir}/libz.dll.a
%{_libdir}/libz.la
%{_includedir}/zconf.h
%{_includedir}/zlib.h
%{_pkgconfigdir}/zlib.pc

%files static
%defattr(644,root,root,755)
%{_libdir}/libz.a

%files dll
%defattr(644,root,root,755)
%{_dlldir}/zlib1.dll
%changelog
* Mon Mar 28 2022 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/crossmingw32-zlib.git;a=log;h=master

* Mon Mar 28 2022 Jakub Bogusz <qboosh@pld-linux.org> 01e1d21
- updated to 1.2.12

* Sun Jan 15 2017 Jakub Bogusz <qboosh@pld-linux.org> f748f83
- updated to 1.2.11

* Sun Jan 15 2017 Jakub Bogusz <qboosh@pld-linux.org> ea9d10b
- updated to 1.2.10; asmopt disabled by default (known to break things)

* Sun Apr 05 2015 Jan Rękorajski <baggins@pld-linux.org> 5a2ed9f
- x32 rebuild
- release 2 (by relup.sh)

* Tue May 07 2013 Jakub Bogusz <qboosh@pld-linux.org> b9ff0d9
- updated to 1.2.8

* Sat Apr 20 2013 Elan Ruusamäe <glen@delfi.ee> 16bc62d
- do not require pkgconfig deps either

* Sun Apr 07 2013 Elan Ruusamäe <glen@delfi.ee> c08184b
- do not provide pkgconfig deps in system namespace

* Sun Apr 07 2013 Elan Ruusamäe <glen@delfi.ee> b5e4487
- added filterout_c for -f* options

* Mon May 07 2012 Jakub Bogusz <qboosh@pld-linux.org> 4d757ee
- updated to 1.2.7

* Tue Jan 31 2012 Jakub Bogusz <qboosh@pld-linux.org> 84eebba
- updated to 1.2.6
- removed obsolete LFS,lfs patches

* Sat Feb 19 2011 Artur Frysiak <artur@frysiak.net> fe09b6e
- no need to filter out any flags with new gcc

* Sat Feb 19 2011 Artur Frysiak <artur@frysiak.net> 9952516
- fix dlname in libtool file
- filter out some compiler and linker flags

* Sun Oct 03 2010 Jakub Bogusz <qboosh@pld-linux.org> 1df373a
- fixed sharedlibdir in zlib.pc
- release 3

* Sun Sep 19 2010 Jakub Bogusz <qboosh@pld-linux.org> 6bf6682
- unified MinGW32 caps

* Mon May 24 2010 Jakub Bogusz <qboosh@pld-linux.org> c247493
- added lfs patch
- release 2

* Wed Apr 21 2010 Jakub Bogusz <qboosh@pld-linux.org> 11d24b3
- updated to 1.2.5

* Sun Mar 21 2010 Jakub Bogusz <qboosh@pld-linux.org> 80a2377
- added LFS patch to export *64 functions from DLL
- release 3

* Sun Mar 21 2010 Jakub Bogusz <qboosh@pld-linux.org> 1712f0c
- import library must be named libz.dll.a for -lz to work
- asm586 is no more (dropped upstream)

* Thu Mar 18 2010 Artur Frysiak <artur@frysiak.net> e7f727b
- use win32/Makefile.gcc for building (for compatibility with other zlib DLL distributors)
- drop shared.patch (unused now)
- drop hacking unused configure
- don't include zutil.h in package (zlib internal file)
- release 2
NOTE: DLL file name change

* Mon Mar 15 2010 Jakub Bogusz <qboosh@pld-linux.org> 7d8bfb0
- updated to 1.2.4 (adds LFS)
- updated shared patch, removed obsolete asmopt patch

